<template>
  <dashboard-layout title="Proprietaires">
    <div class="container-fluid" style="margin: 20px 0 0 0;">
        <div v-if="isLoading">
          <div class="p-5" v-if="isLoading">
            <fulfilling-bouncing-circle-spinner
              class="mx-auto"
              :animation-duration="2000"
              :size="60"
              :color="'#6D071A'"
            />
          </div>
        </div>
        <div v-else>
          <!-- show -->
          <div v-if="!creating && !editing" class="col-sm">
            <div class=" mb-2">
              <div class="row mb-1">
                <div class="col-sm-3"></div>
                <h3 class="text-center col-sm-6">Liste des Locations</h3>
                <div class="text-right col-sm-3">
                  <div class="form-group">
                    <input class="btn btn-light btn-block"
                      value="Ajouter" @click="creating = true"/>
                  </div>
                </div>
              </div>
              <div class="">
                <ListLocations />
              </div>
            </div>
          </div>
          <!-- create -->
          <div class="col-sm-12 row mx-auto" v-if="creating">
            <div class="card col-sm-12 rounded shadow">
              <div class="card-body">
                <div class="text-left cursor-p mb-2" @click="creating = false">
                  <i class="fa fa-arrow-left mr-1"></i>
                </div>
                <hr />
                <h3 class="text-center">Ajouter une location</h3>
                <hr />
                <div class="alert alert-danger" v-if="errorMessage">
                  {{ errorMessage }}
                </div>
                <form @submit="create" >
                  <div class="row col-12">
                    <!-- first group -->
                    <div class="col-6 ">
                      <div class="form-group">
                        <label class="pb-2">Adresse</label>
                        <input type="text" class="form-control"
                          v-model="address"/>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label class="pb-2 pl-2">Prix (F CFA)</label>
                          <input
                            type="number" min=0
                            class="form-control"
                            v-model="newLocation.price"/>
                        </div>
                        <div class="form-group col-6">
                          <label class="pb-2 pl-2" >Zone</label>
                          <input
                            type="text" class="form-control"
                            v-model="newLocation.zone"/>
                        </div>
                      </div>
                      <div class="form-group">
                        <label>Propriétaire</label>
                        <v-select :options="proprietaires"
                          :reduce="item => item.code"
                          class="form-control-select"
                          v-model="newLocation.proprietaire" required>
                          </v-select>
                      </div>
                      <div v-if="adminLog" class="form-group">
                        <label>Agence</label>
                        <v-select :options="agences"
                          :reduce="item => item.code"
                          class="form-control-select"
                          v-model="newLocation.agence" required>
                        </v-select>
                      </div>
                      <div class="form-group">
                        <label>Description de la location</label>
                        <textarea class="col-sm" rows="2"
                          v-model="newLocation.message">
                        </textarea>
                      </div>
                      <div class="row">
                        <div class="col-sm-6" v-for="(picture, i) in importFiles" :key="i">
                          <div class="form-group">
                            <label for="photo">{{i == 0 ? 'Photo principale' : 'Photo ' + (i+1)}}</label>
                            <div :class="'custom-file' + (imageData[i] ? ' filled' : '')">
                              <div
                                class="img-preview"
                                :style="'background-image: url(' + imageData[i] + ')'"
                              ></div>
                              <input
                                type="file"
                                class="custom-file-input"
                                :id="'customFile' + i"
                                :ref="'file' + i"
                                @change="handleFileUpload(i)"
                              />
                              <label
                                class="custom-file-label"
                                :for="'customFile' + i"
                              >{{ picture.name || 'Choisir une photo'}}</label>
                            </div>
                        </div>
                        </div>
                      </div>
                    </div>
                    <!-- second group -->
                    <div class="col-6">
                      <div class="row">
                        <div class="form-group col-6">
                          <label class="pb-2" >Nombre de ménage</label>
                          <input
                            type="number" min=0 class="form-control"
                            v-model="newLocation.description.nbreMenages"/>
                        </div>
                        <div class="form-group col-6">
                          <label class="pb-2" >Superficie (m <sup>2</sup>)</label>
                          <input
                            type="number" min=0 class="form-control"
                            v-model="newLocation.description.superficie"/>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label class="pb-2 pl-2">Nombre de chambres</label>
                          <input
                            type="number" min=0
                            class="form-control"
                            v-model="newLocation.description.nbreChambres"/>
                        </div>
                        <div class="form-group col-6">
                          <label class="pb-2 pl-2">Nombre de salons</label>
                          <input
                            type="number" class="form-control" min=0
                            v-model="newLocation.description.nbreSalons"/>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label class="pb-2 pl-2">Nombre de douches</label>
                          <input
                            type="number" min=0 class="form-control"
                            v-model="newLocation.description.nbreDouches"/>
                        </div>
                        <div class="form-group col-6">
                          <label class="pb-2 pl-2">Nbre de cuisines</label>
                          <input
                            type="number" min=0 class="form-control"
                            v-model="newLocation.description.nbreCuisines"/>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label>Couloir</label>
                          <select class="form-control" v-model="newLocation.description.couloir">
                            <option value=true>Oui </option>
                            <option value=false>Non</option>
                          </select>
                        </div>
                        <div class="form-group col-6">
                          <label>Garage</label>
                          <select class="form-control" v-model="newLocation.description.garage">
                            <option value=true>Oui </option>
                            <option value=false>Non</option>
                          </select>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label>Arrière cour</label>
                          <select class="form-control" v-model="newLocation.description.arriereCour">
                            <option value=true>Oui </option>
                            <option value=false>Non</option>
                          </select>
                        </div>
                        <div class="form-group col-6">
                          <label>Cuisine interne</label>
                          <select class="form-control" v-model="newLocation.description.cuisineInterne">
                            <option value=true>Oui </option>
                            <option value=false>Non</option>
                          </select>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label>Sanitaire</label>
                          <select class="form-control" v-model="newLocation.description.sanitaire">
                            <option value=true>Oui </option>
                            <option value=false>Non</option>
                          </select>
                        </div>
                        <div class="form-group col-6">
                          <label>Nouvelle Contruction</label>
                          <select class="form-control" v-model="newLocation.description.nouvelleConstruction">
                            <option value=true>Oui </option>
                            <option value=false>Non</option>
                          </select>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label>Genre de location</label>
                          <select class="form-control" v-model="newLocation.description.genreLocation">
                            <option value="Entrée Couché">Entrée Couché</option>
                            <option value="Rez">Rez</option> 
                            <option value="Duplex">Duplex </option>
                            <option value="Triplex">Triplex</option>
                            <option value="R+1">R+1</option>
                            <option value="R+2">R+2</option>
                            <option value="R+3">R+3</option>
                            <option value="R++">R++</option>
                          </select>
                        </div>
                        <div class="form-group col-6">
                          <label>Type de compteur</label>
                          <select class="form-control" v-model="newLocation.description.typeCompteur">
                            <option value="Conventionnel">Conventionnel</option>
                            <option value="Carte">Carte</option>
                          </select>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group col-6">
                          <label>Eau</label>
                          <select class="form-control" v-model="newLocation.description.eau">
                            <option value="Soneb">Soneb</option>
                            <option value="Forage">Forage</option>
                            <option value="Forage et Soneb">Forage et Soneb</option>
                          </select>
                        </div>
                        <div class="form-group col-6">
                          <label>Aération</label>
                          <select class="form-control" v-model="newLocation.description.aeration">
                            <option value="Aucune">Aucune</option>
                            <option value="Ventilateur">Ventilateur</option>
                            <option value="Climatiseur">Climatiseur</option>
                            <option value="Ventilateur et Climatiseur">Ventilateur et Climatiseur</option>
                          </select>
                        </div>
                      </div>
                    </div>
                    <div class="form-group col-12 mt-2">
                      <input type="submit" class="btn btn-light btn-block"
                        value="Ajouter"/>
                    </div>
                  </div>
                </form>
              </div>
            </div>
          </div>
        </div>
          </div>
  </dashboard-layout>
</template>

<script>
export default {
  name: "home",
  data() {
    return {
      locations: [],
      agences: [],
      proprietaires: [],

      importFiles: [],
      imageData: [],
      fileNumber: 4,

      isLoading: false,
      creating: true,
      editing: false,
      errorMessage: "",
      curPage: 1,
      perPage: 100,
      newLocation: {
        agence: '',
        description: {
        },
        address: {
          longitude: 0,
          latitude: 0
        }
      },
      adminLog: false,
      editingLocaion: {
        agence: '',
        proprietaire: '',
        description: {
        }
      },
      total: 0,
      userDatas: "",
      editingId:'',
      currentAgence: '',
      address: "",
      position: { },
    };
  },
  mounted() {
    this.init();
    this.geolocate();
    this.getProprietaires();

    for (var i = 0; i < this.fileNumber; i++) {
      this.importFiles.push({});
      this.imageData.push("");
    }

    if (localStorage.getItem("adminRole") == 'agence' ){
      this.newLocation.agence = localStorage.getItem("adminId");
      this.editingLocaion.agence = localStorage.getItem("adminId");
      this.userDatas = JSON.parse(localStorage.getItem("adminInfo"));
    }else{
      this.adminLog = true;
      this.getAgences();
    }
  },
  methods: {
    geolocate() {
      navigator.geolocation.getCurrentPosition(position => {
        this.position = {
          latitude: position.coords.latitude,
          longitude: position.coords.longitude,
        };
        this.address = this.position.latitude+"|"+this.position.longitude;
      });
    },
    handleFileUpload(index) {
      console.log(this.$refs["file" + index][0]);
      this.importFiles[index] = this.$refs["file" + index][0].files[0];
      if (this.importFiles[index]) {
        const reader = new FileReader();
        reader.onload = (e) => {
          this.imageData[index] = e.target.result;
          this.$forceUpdate();
        };
        reader.readAsDataURL(this.importFiles[index]);
      }
      this.$forceUpdate();
    },
    init(page, resetParams) {
      if (resetParams) {
        this.curPage = 1;
      }
      let query = query = {
        options: {},
        sort: {
          createdAt: -1,
        },
      };
      if(!this.adminLog)
        query.options.agence = localStorage.getItem("adminId");
      this.isLoading = true;
      this.$service.list("locations", query, (err, data) => {
        if (err) {
          return console.log(err);
        }
        console.log('results',data)
        this.isLoading = false;
        this.errorMessage = "";
        this.locations = data.locations;
        this.total = data.locations.length;
      });
    },
    getAgences(){
      const query = {
        options: {
          role: "agence",
        },
        page: 0,
        perPage: 100
      };
      this.$service.listAdmins(query, (err, data) => {
        if (err) {
          console.log(err);
          return;
        }
        this.errorMessage = "";
        this.agences = data.admins.map(admin => {
          return {
            label: admin.name,
            code: admin._id
          };
        });
      });
    },
    getProprietaires(){
      const query = {
        options: {
        },
        page: 0,
        perPage: 100
      };
      this.$service.list("proprietaires", query, (err, data) => {
        if (err) {
          console.log(err);
          return;
        }
        this.errorMessage = "";
        this.proprietaires = data.proprietaires.map(proprio => {
          return {
            label: proprio.fullname,
            code: proprio._id
          };
        });
      });
    },
    create(e) {
      e.preventDefault();
      this.isLoading = true; this.creating = false;
      
      //this.newLocation.address = this.position;
      this.newLocation.address.latitude = 6.48303723853065;
      this.newLocation.address.longitude =  2.3476662689417416;

      let formData = new FormData();
      formData.append("fileprop", "pictures");
      formData.append("filenumber", this.fileNumber);
      formData.append("objectdata", JSON.stringify(this.newLocation));
      for (var i = 0; i < this.fileNumber; i++) {
        if (this.importFiles[i].name) {
          formData.append("filedata" + i, this.importFiles[i]);
        }
      }
      
      //console.log('newLocation: ',this.newLocation);
      this.$service.createWithFile("locations", formData, (err, data) => {
        if (err) {
          this.errorMessage = err.data && err.data.message;
          console.log("Error", err.data);
          return;
        }
        console.log("retour de l api, create location ", data);        
        this.newLocation = {
          agence: '',
          description: {
          }
        };

        let datas = {
          admin : localStorage.getItem("adminId"),
          location: data.resource._id, 

          message: 'create location',
          date: new Date(),
          position : this.position,
        }
        this.$service.create("historiques", datas, (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            return;
          }
          this.creating = this.isLoading = false;
          this.$swal.fire("Ajout réussie", "", "success").then(() => {
            this.init();
          });
        });
      });
    },
    editLocation(location) {
      this.editingId = proprio._id;
      this.editingProprio.fullname = proprio.fullname;
      this.editingProprio.email = proprio.email;
      this.editingProprio.phone = proprio.phone;
      this.editingProprio.agence = proprio.agence._id;
      this.currentAgence = "Agence actuelle : " +proprio.agence.name;

      this.editing = true;
    },
    update(e) {
      e.preventDefault();
      //console.log(this.editingId,this.editingProprio)
      this.$service.update("locations",this.editingId,this.editingLocaion,
        (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            console.log("Error", err.data);
            return;
          }
          this.editing = false;

          this.editingLocaion = {
            fullname: '0',
            email: '0',
            phone: "",
            agence: ""
          },
          this.init();
          this.$swal.fire("Modification réussie", "", "success").then(() => {});
        }
      );
    },
    removeLocation(id) {
      this.$swal
        .fire({
          title: "Voulez-vous vraiment supprimer?",
          text: "Vous ne pouvez plus récuperer ces données !",
          icon: "warning",
          showCancelButton: true,
          cancelButtonColor: "#3085d6",
          confirmButtonColor: "#d33",
          confirmButtonText: "Oui, supprimer!",
        })
        .then((result) => {
          if (result.value) {
            this.$service.remove("locations", id, (err, data) => {
              if (err) {
                this.errorMessage = err.data && err.data.message;
                console.log("Error", err.data);
                return;
              }
              this.$swal
                .fire(
                  "Suppression réussie",
                  "La suppression s'est effectuée avec succès",
                  "success"
                )
                .then(() => {
                  this.init();
                });
            });
          }
        });
    },
  },
};
</script>